Index: branches/libIGCM_MPI_OpenMP/libIGCM_date/libIGCM_date.ksh
===================================================================
--- branches/libIGCM_MPI_OpenMP/libIGCM_date/libIGCM_date.ksh	(revision 570)
+++ branches/libIGCM_MPI_OpenMP/libIGCM_date/libIGCM_date.ksh	(revision 571)
@@ -726,71 +756,192 @@
 function IGCM_date_DaysSinceJC
 {
-    IGCM_debug_PushStack "IGCM_date_DaysSinceJC" $@
-
-    # calculates the days difference between a date and 00010101
-    # usage IGCM_date_DaysSinceJC grg1
-    # where gregorian date is in the form yyyymmdd
-
-    usage () {
- 	echo "Usage:"
- 	echo " IGCM_date_DaysSinceJC grg1"
- 	echo ""
- 	echo " Calculate day difference between"
- 	echo " a gregorian date and 00010101"
- 	echo " where a gregorian date is in the form of yyyymmdd."
-    }
-
-    if [ $# -lt 1 ]; then
- 	usage
-	IGCM_debug_Exit "IGCM_date_DaysSinceJC"
-    fi
-    
-    typeset aux num
-
-    if   [ ${1} -lt  5000000 ]; then
-	case ${config_UserChoices_CalendarType} in
-	    360d|360_day) 
-		aux=-360;;
-	    noleap|365_day)
-		aux=-365;;
-	    all_leap|366_day) 
-		aux=-366;;
-	    leap|gregorian|standard)
-		aux=-366;;
-	esac
-	num=101
-    elif [ ${1} -lt 15000000 ]; then
-        # To save CPU type we use auxiliary value
-        # which is number of days since JC and 10000101
-	case ${config_UserChoices_CalendarType} in
-	    360d|360_day) 
-		aux=359640;;
-	    noleap|365_day)
-		aux=364635;;
-	    all_leap|366_day) 
-		aux=365634;;
-	    leap|gregorian|standard)
-		aux=364877;;
-	esac
-	num=10000101
-    else
-        # To save CPU type we use auxiliary value
-        # which is number of days since JC and 19000101
-	case ${config_UserChoices_CalendarType} in
-	    360d|360_day) 
-		aux=683640;;
-	    noleap|365_day)
-		aux=693135;;
-	    all_leap|366_day) 
-		aux=695034;;
-	    leap|gregorian|standard)
-		aux=693595;;
-	esac
-	num=19000101
-    fi
-    echo $(( $( IGCM_date_DaysBetweenGregorianDate $1 ${num} ) + $aux ))
-
-    IGCM_debug_PopStack "IGCM_date_DaysSinceJC"
-}
+  IGCM_debug_PushStack "IGCM_date_DaysSinceJC" $@
+
+  # calculates the days difference between a date and 00010101
+  # usage IGCM_date_DaysSinceJC grg1
+  # where gregorian date is in the form yyyymmdd
+
+  usage () {
+    echo "Usage:"
+    echo " IGCM_date_DaysSinceJC grg1"
+    echo ""
+    echo " Calculate day difference between"
+    echo " a gregorian date and 00010101"
+    echo " where a gregorian date is in the form of yyyymmdd."
+  }
+
+  if [ $# -lt 1 ]; then
+    usage
+    IGCM_debug_Exit "IGCM_date_DaysSinceJC"
+  fi
+  
+  typeset aux num
+
+  if   [ ${1} -lt  5000000 ]; then
+    case ${config_UserChoices_CalendarType} in
+    360d|360_day) 
+      aux=-360;;
+    noleap|365_day)
+      aux=-365;;
+    all_leap|366_day) 
+      aux=-366;;
+    leap|gregorian|standard)
+      aux=-366;;
+    esac
+    num=101
+  elif [ ${1} -lt 15000000 ]; then
+    # To save CPU type we use auxiliary value
+    # which is number of days since JC and 10000101
+    case ${config_UserChoices_CalendarType} in
+    360d|360_day) 
+      aux=359640;;
+    noleap|365_day)
+      aux=364635;;
+    all_leap|366_day) 
+      aux=365634;;
+    leap|gregorian|standard)
+      aux=364877;;
+    esac
+    num=10000101
+  else
+    # To save CPU type we use auxiliary value
+    # which is number of days since JC and 19000101
+    case ${config_UserChoices_CalendarType} in
+    360d|360_day) 
+      aux=683640;;
+    noleap|365_day)
+      aux=693135;;
+    all_leap|366_day) 
+      aux=695034;;
+    leap|gregorian|standard)
+      aux=693595;;
+    esac
+    num=19000101
+  fi
+  echo $(( $( IGCM_date_DaysBetweenGregorianDate $1 ${num} ) + $aux ))
+
+  IGCM_debug_PopStack "IGCM_date_DaysSinceJC"
+}
+
+#D-#==================================================================
+#D-function IGCM_date_DaysInPreviousPeriod ()
+#D-* Purpose: Give the numbers of days during the previous prd1 period from grg1 date # OLD create_ts_begin_date
+#D-* Usage: IGCM_date_DaysInPreviousPeriod grg1 prd1 [end]
+#D-         where grg1 gregorian date is in the form yyyymmdd
+#D-         where prd1 period is in the form N[Yy], N[Mm], N[Dd]. N integer
+#D-         where [end] is an optionnal keyword to specify grg1 is the end of prd1
+#D-
+function IGCM_date_DaysInPreviousPeriod {
+  IGCM_debug_PushStack "IGCM_date_DaysInPreviousPeriod" $@
+  typeset Length Period
+  Period=${2}
+  case ${Period} in
+  *Y|*y)
+    PeriodLengthInYears=$( echo ${Period} | awk -F '[yY]' '{print $1}' )
+    IGCM_date_GetYearMonth ${1} year month
+    year=$( IGCM_date_SupressZeros ${year} )
+    if [ X${2} = Xend ] ; then
+      (( year = year - PeriodLengthInYears + 1))
+    fi
+    (( Length=0 ))
+    (( i=0 ))
+    until [ $i -ge $PeriodLengthInYears ] ; do
+      (( Length = Length + $( IGCM_date_DaysInYear $(( year + i )) ) )) 
+      (( i=i+1 ))
+    done
+    ;;
+  *M|*m)
+    PeriodLengthInMonths=$( echo ${Period} | awk -F '[mM]' '{print $1}' )
+    IGCM_date_GetYearMonth ${1} year month
+    year=$( IGCM_date_SupressZeros ${year} )
+    if [ X${2} = Xend ] ; then
+      (( month = month - PeriodLengthInMonths + 1 ))
+    fi	    
+    (( year0 = year ))
+    if [ $month -le 0 ] ; then
+      (( month = month + 12 ))
+      year=$( printf "%04i\n" $(( year - 1 )) )
+    fi
+    month=$( printf "%02i\n" ${month} )
+    (( Length=0 ))
+    (( i=0 ))
+    until [ $i -ge $PeriodLengthInMonths ] ; do
+      if [ $(( month + i )) -lt 13 ] ; then
+	(( Length = Length + $( IGCM_date_DaysInMonth $year $(( month + i )) ) ))
+      else
+	(( year = year0 + 1 ))
+	(( Length = Length + $( IGCM_date_DaysInMonth $year $(( month + i - 12 )) ) ))
+      fi
+      (( i=i+1 ))
+    done
+    ;;
+  *D|*d)
+    Length=$( echo ${Period} | sed -e "s/[dD]//" ) ;;
+  *)
+    IGCM_debug_Exit "IGCM_date_DaysInPreviousPeriod " ${Period} " invalid PeriodLength : choose in *Y, *M, *D."
+    IGCM_debug_Verif_Exit_Post ;;
+  esac
+  echo ${Length}
+
+  IGCM_debug_PopStack "IGCM_date_DaysInPreviousPeriod"
+}
+
+#D-#==================================================================
+#D-function IGCM_date_DaysInNextPeriod ()
+#D-* Purpose: Give the numbers of days during the next prd1 period from grg1 date # OLD create_ts_next_date
+#D-* Usage: IGCM_date_DaysInNextPeriod grg1 prd1
+#D-         where grg1 gregorian date is in the form yyyymmdd
+#D-         where prd1 period is in the form N[Yy], N[Mm], N[Dd]. N integer
+#D-
+function IGCM_date_DaysInNextPeriod {
+  IGCM_debug_PushStack "IGCM_date_DaysInNextPeriod" $@
+  typeset Length Period
+  Period=${2}
+  case ${Period} in
+  *Y|*y) 
+    PeriodLengthInYears=$( echo ${Period} | awk -F '[yY]' '{print $1}' )
+    IGCM_date_GetYearMonth ${1} year month
+    year=$( IGCM_date_SupressZeros ${year} )
+    (( Length=0 ))
+    (( i=0 ))
+    until [ $i -ge $PeriodLengthInYears ] ; do
+      (( Length = Length + $( IGCM_date_DaysInYear $(( year + i + 1 )) ) )) 
+      (( i=i+1 ))
+    done
+    ;;
+  *M|*m) 
+    PeriodLengthInMonths=$( echo ${Period} | awk -F '[mM]' '{print $1}' )
+    IGCM_date_GetYearMonth ${1} year month
+    year=$( IGCM_date_SupressZeros ${year} )
+    (( year0 = year ))
+    if [ $(( month + 1 )) -lt 13 ] ; then
+      month0=$(( month + 1 ))
+    else
+      month0=$(( month + 1 - 12 ))
+      (( year = year0 + 1 ))
+    fi
+    (( Length=0 ))
+    (( i=0 ))
+    until [ $i -ge $PeriodLengthInMonths ] ; do
+      if [ $(( month0 + i )) -lt 13 ] ; then
+	(( Length = Length + $( IGCM_date_DaysInMonth $year $(( month0 + i )) ) ))
+      else
+	(( year = year0 + 1 ))
+	(( Length = Length + $( IGCM_date_DaysInMonth $year $(( month0 + i - 12 )) ) ))
+      fi
+      (( i=i+1 ))
+    done
+    ;;
+  *D|*d)
+    Length=$( echo ${Period} | sed -e "s/[dD]//" ) ;;
+  *)
+    IGCM_debug_Exit "IGCM_date_DaysInNextPeriod " ${Period} " invalid PeriodLength : choose in *Y, *M, *D."
+    IGCM_debug_Verif_Exit_Post ;;
+  esac
+  echo ${Length}
+
+  IGCM_debug_PopStack "IGCM_date_DaysInNextPeriod"
+}
+
 
 #D-#==================================================================
@@ -799,39 +950,39 @@
 function IGCM_date_Check
 {
-    IGCM_debug_PushStack "IGCM_date_Check"
+  IGCM_debug_PushStack "IGCM_date_Check"
 
 #---------------------
-    if [ ! -n "${libIGCM}" ] ; then
-	echo "Check libIGCM_date ...........................................[ FAILED ]"
-        echo "--Error--> libIGCM variable is not defined"
-	IGCM_debug_Exit "IGCM_date_Check"
-    fi
+  if [ ! -n "${libIGCM}" ] ; then
+    echo "Check libIGCM_date ...........................................[ FAILED ]"
+    echo "--Error--> libIGCM variable is not defined"
+    IGCM_debug_Exit "IGCM_date_Check"
+  fi
 
 #---------------------
-    whence -v gawk > /dev/null 2>&1
-    if [ ! $? -eq 0 ] ; then
-	echo "Check libIGCM_date ...........................................[ FAILED ]"
-        echo "--Error--> gawk command is not defined"
-	IGCM_debug_Exit "IGCM_date_Check"
-    fi
+  whence -v gawk > /dev/null 2>&1
+  if [ ! $? -eq 0 ] ; then
+    echo "Check libIGCM_date ...........................................[ FAILED ]"
+    echo "--Error--> gawk command is not defined"
+    IGCM_debug_Exit "IGCM_date_Check"
+  fi
 
 #---------------------
-    ${libIGCM}/libIGCM_date/IGCM_date_Test.ksh > IGCM_date_Test.ref.failed 2>&1
-    
-    if diff IGCM_date_Test.ref.failed ${libIGCM}/libIGCM_date/IGCM_date_Test${dY}.ref > /dev/null 2>&1 ; then 
-	echo "Check libIGCM_date ...............................................[ OK ]"
-	rm -f IGCM_date_Test.ref.failed
-    else 
-	echo "Check libIGCM_date ...........................................[ FAILED ]"
-        echo "--Error--> Execution of ${libIGCM}/libIGCM_date/IGCM_date_Test.ksh"
-        echo "           has produced the file IGCM_date_Test.ref.failed"
-        echo "           Please analyse differences with the reference file by typing:"
-        echo "           diff IGCM_date_Test.ref.failed ${libIGCM}/libIGCM_date/IGCM_date_Test${dY}.ref"
-	echo "           Report errors to the author: Sebastien.Denvil@ipsl.jussieu.fr"
-	IGCM_debug_Exit "IGCM_date_Check"
-    fi
+  ${libIGCM}/libIGCM_date/IGCM_date_Test.ksh > IGCM_date_Test.ref.failed 2>&1
+  
+  if diff IGCM_date_Test.ref.failed ${libIGCM}/libIGCM_date/IGCM_date_Test${dY}.ref > /dev/null 2>&1 ; then 
+    echo "Check libIGCM_date ...............................................[ OK ]"
+    rm -f IGCM_date_Test.ref.failed
+  else 
+    echo "Check libIGCM_date ...........................................[ FAILED ]"
+    echo "--Error--> Execution of ${libIGCM}/libIGCM_date/IGCM_date_Test.ksh"
+    echo "           has produced the file IGCM_date_Test.ref.failed"
+    echo "           Please analyse differences with the reference file by typing:"
+    echo "           diff IGCM_date_Test.ref.failed ${libIGCM}/libIGCM_date/IGCM_date_Test${dY}.ref"
+    echo "           Report errors to the author: Sebastien.Denvil@ipsl.jussieu.fr"
+    IGCM_debug_Exit "IGCM_date_Check"
+  fi
 
 #---------------------
-    IGCM_debug_PopStack "IGCM_date_Check"
+  IGCM_debug_PopStack "IGCM_date_Check"
 }
 
Index: branches/libIGCM_MPI_OpenMP/libIGCM_post/check_expe_files_size.sh
===================================================================
--- branches/libIGCM_MPI_OpenMP/libIGCM_post/check_expe_files_size.sh	(revision 570)
+++ branches/libIGCM_MPI_OpenMP/libIGCM_post/check_expe_files_size.sh	(revision 571)
@@ -125,5 +125,5 @@
 # On deduit de la liste des fichiers des patterns de annee+mois, annee, intervalles de date ...
 sed -r \
-    -e 's/[0-2][0-9]{3}[01][0-9]/YYMM/g' \
+    -e 's/[0-5][0-9]{3}[01][0-9]/YYMM/g' \
     -e 's/YYMM01_YYMM(28|29|30|31)/YYmmdd_YYmmdd/g' \
                                            /tmp/$$.ldir | sort -u > /tmp/$$.lpat
@@ -146,5 +146,5 @@
         # On transforme le pattern pour mettre une sequences  
         # de capture des annees de debut et fin d'intervalle
-        p2=$(echo $pattern | sed -e 's/YYmmdd_YYmmdd/([0-2][0-9]{3}[01][0-9])01_[0-2][0-9]{3}[01][0-9](28|29|30|31)/g' )
+        p2=$(echo $pattern | sed -e 's/YYmmdd_YYmmdd/([0-5][0-9]{3}[01][0-9])01_[0-5][0-9]{3}[01][0-9](28|29|30|31)/g' )
 
        # On balaye le repertoire avec le(s) pattern(s) transforme(s) pour capturer les annees
@@ -162,5 +162,5 @@
     awk '{
         if (NR==1) {avant=$1; print $1}
-        else { for (i=avant+1 ; i<=$1 ; i++) print i}}'
+        else { for (i=avant+1 ; i<=$1 ; i++) printf "%04i\n", i}}'
 }
 sort -u /tmp/$$.dates > /tmp/$$.toutes_dates
@@ -227,5 +227,5 @@
            # On transforme le pattern pour mettre une sequences  
            # avec le mois courant
-           px=$(echo $pattern | sed -e "s/YYmmdd_YYmmdd/([0-2][0-9]{3})${mois}01_[0-2][0-9]{3}${mois}(28|29|30|31)/g" )
+           px=$(echo $pattern | sed -e "s/YYmmdd_YYmmdd/([0-5][0-9]{3})${mois}01_[0-5][0-9]{3}${mois}(28|29|30|31)/g" )
 
            # On balaye le repertoire avec le(s) pattern(s) transforme(s) pour capturer les tailles des fichiers de ce mois
